/*! * WQMS Main Function */
(function() 
{
	WQMS = {
		
		alamat: "",
		alamat_cdn: "",
		tema: "",
		tarikh: "",
		parameter: "WQI",
		carta: "",
		chart: "",
		carta3: "",
		blnSyamsiah: [ "Januari", "Februari", "Mac", "April", "Mei", "Jun", "Julai", "Ogos", "September", "Oktober", "November", "Disember" ],
		susunParam: [ "pH", "NH3", "DO (%)", "BOD", "COD", "TSS", "WQI" ],
		Pengkelasan_Param: function ( param, nil ) {
			var $kelas;
			switch(param)
			{
				case 'WQI':
					if(nil < 29.61)
						$kelas = 'V';
					else if ((nil>29.61) && (nil<51.68))
						$kelas = 'IV';
					else if((nil>51.68) && (nil<75.37))
						$kelas = 'III';
					else if((nil>75.37) && (nil<91.76))
						$kelas = 'II';
					else if(nil>91.76)
						$kelas = 'I';
					break;
				case 'NH3':
					if(nil > 2.7)
						$kelas = 'V';
					else if ((nil>0.9) && (nil<2.7))
						$kelas = 'IV';
					else if((nil>0.3) && (nil<0.9))
						$kelas = 'III';
					else if((nil>0.1) && (nil<0.3))
						$kelas = 'II';
					else if(nil<0.1)
						$kelas = 'I';
					break;
				case 'pH':
					if(nil<5)
						$kelas = 'V';
					else if (nil<5)
						$kelas = 'IV';
					else if((nil>5) && (nil<6))
						$kelas = 'III';
					else if((nil>6) && (nil<7))
						$kelas = 'II';
					else if(nil>7)
						$kelas = 'I';
					break;
				case 'BOD':
					if(nil>12)
						$kelas = 'V';
					else if ((nil>6) && (nil<12))
						$kelas = 'IV';
					else if((nil>3) && (nil<6))
						$kelas = 'III';
					else if((nil>1) && (nil<3))
						$kelas = 'II';
					else if(nil<1)
						$kelas = 'I';
					break;
				case 'COD':
					if(nil>100)
						$kelas = 'V';
					else if ((nil>50) && (nil<100))
						$kelas = 'IV';
					else if((nil>25) && (nil<50))
						$kelas = 'III';
					else if((nil>10) && (nil<25))
						$kelas = 'II';
					else if(nil<10)
						$kelas = 'I';
					break;
				case 'TSS':
					if(nil>300)
						$kelas = 'V';
					else if ((nil>150) && (nil<300))
						$kelas = 'IV';
					else if((nil>50) && (nil<150))
						$kelas = 'III';
					else if((nil>25) && (nil<50))
						$kelas = 'II';
					else if(nil<25)
						$kelas = 'I';
					break;
				case 'DO':
					var nil = (nil/100) * 8;
					if(nil<1)
						$kelas = 'V';
					else if ((nil>1) && (nil<3))
						$kelas = 'IV';
					else if((nil>3) && (nil<5))
						$kelas = 'III';
					else if((nil>5) && (nil<7))
						$kelas = 'II';
					else if(nil>7)
						$kelas = 'I';
					break;
				default:
					if(nil < 29.61)
						$kelas = 'V';
					else if ((nil>29.61) && (nil<51.68))
						$kelas = 'IV';
					else if((nil>51.68) && (nil<75.37))
						$kelas = 'III';
					else if((nil>75.37) && (nil<91.76))
						$kelas = 'II';
					else if(nil>91.76)
						$kelas = 'I';
					break;
			}
			return $kelas;
		},
		isEmptyObject: function (obj)
		{
			for(var propName in obj){
					if(obj.hasOwnProperty(propName)){
							return false;
					}
			}
			return true;
    },
		silakan_makan: function  ( dt )
		{
			var $bar = $('.bar');
			$("#badaba").hide("slow");
			$("table.table > tbody").empty();
			$.getJSON(WQMS.alamat+'table_for_daily_data.php', {dt: dt}, function(data) {
				$.each(data, function(index, lol) {
					var scan_date = $('<td></td>').html(lol.scan_date);
					var suhu      = $('<td></td>').html(lol.temp);
					var pH        = $('<td></td>').html(lol.pH);
					var nh4       = $('<td></td>').html(lol.NH4);
					var tDO       = $('<td></td>').html(lol.LDO);
					var dosat     = $('<td></td>').html(lol.dosat);
					var BOD       = $('<td></td>').html(lol.BOD);
					var COD       = $('<td></td>').html(lol.COD);
					var TSS       = $('<td></td>').html(lol.TSS);
					var wqi       = $('<td></td>').html(lol.wqi);
					var WQClass   = $('<td></td>').html(lol.WQClass);
					var newTr     = $('<tr></tr>');
					newTr.append(scan_date).show('slow');
					newTr.append(suhu).show('normal');
					newTr.append(pH).show('normal');
					newTr.append(nh4).show('slow');
					newTr.append(tDO).show('slow');
					newTr.append(dosat).show('slow');
					newTr.append(BOD).show('normal');
					newTr.append(COD).show('slow');
					newTr.append(TSS).slideDown("slow");
					newTr.append(wqi).show('normal');
					newTr.append(WQClass).show('slow');
					$("table.table").append(newTr);

				});
				$("#badaba").show("slow");
				$("table.table").show();
			});
		},
		grafHarini_d_smlm: function( param, dt )
		{
			var d = dt.split("-");
			var tarikh = new Date( d[0],(d[1]-1),d[2] );
			
			tarikh = tarikh.getDate() + ' ' + WQMS.blnSyamsiah[tarikh.getMonth()] + ' ' + tarikh.getFullYear();
			
			var unitz = '&#37;';
			if ( param == 'WQI' )
				unitz = '&#37;';
			else if ( param == 'pH' )
				unitz = '';
			else if ( param == 'NH3' )
				unitz = 'mg/L';
			else if ( param == 'DO' )
				unitz = '&#37;';
			else if ( param == 'BOD' )
				unitz = 'mg/L';
			else if ( param == 'COD' )
				unitz = 'mg/L';
			else if ( param == 'TSS' )
				unitz = 'mg/L';
				
			WQMS.chart = new Highcharts.Chart({
				global: {useUTC: false},
				chart: {
					renderTo: 'placeholder',
					type: 'area',
					events: {
						click: function() {
							$('[rel="popover"]').popover('destroy');
						}
					}
				},
				title: {text: null},
				xAxis: {type: 'datetime',
								dateTimeLabelFormats: {
									hour: '%H:%M',
									day: '%H'
								}
				},
				yAxis: {title: {
										text: null
								}},
				legend: {
					enabled: true
				},		
				series: [],
				
				tooltip: {
					 borderColor: "#000",
					 style: {
							color: '#000'
					 },
					formatter: function() {
						var s = 'Masa: <b>'+ Highcharts.dateFormat('%H:%M', this.x) +'</b> ';
						var beza = 0;
						var warna_beza = '#5BB75B';
						$.each(this.points, function(i, point) {
								s += '<br/><span style="color: ' + point.series.color + '">'+ point.series.name +'</span>: '+point.y;
								if (i == 1) {
									beza = beza - point.y;
									if (beza < 0)
										warna_beza = '#B94A48';
									s += '<br/><span style="color: ' + warna_beza + '">' + beza.toFixed(2) + '</span>';
								} else
									beza = point.y;
								
						});
						return s;
					},
					shared: true			
				},
				plotOptions: {
					area: {
						allowPointSelect: true,
						fillOpacity: 0.5,
						marker: {
								enabled: true,
								radius: 0.1,
								states: {
										select: {
												radius: 3
										}
								}
						}
					},
					series: {
						point: {
							events: {
									click: function() {
											$('[rel="popover"]').popover('destroy');
											var warna_beza = '#5BB75B';
											var beza = 0, selected = !this.selected;
											this.select(selected, false);
											index = this.series.index;
											x = this.x;
											$('h2#masa').html( tarikh + ' ' + Highcharts.dateFormat('%H:%M', x) );
											
											$.each(this.series.chart.series, function(i, pointz) {
												if (pointz.index === index) {
													$(pointz.data).each(function(j, point){
														if(x === point.x)													
															if(point.utk_tunjuk == 1) {
																//console.log(point);
																point.select(selected, true);
																$('.keterangan-parameter').show();
																$('#ika').html(point.y + '<small>' + unitz + '</small>');
																$('h2#kelas').html(WQMS.Pengkelasan_Param( param, point.y));
																$('a#persampelan').attr('href', WQMS.alamat + 'persampelan/?dt=' + x);
																$("div.keterangan-parameter div.span4").first().show("fast", function showNext() {
																		$(this).next("div.keterangan-parameter div.span4").show("fast", showNext);
																});
															}	else {
																$('#ika').html('NaN');
																$('h2#kelas').html('NaN');
																$("div.keterangan-parameter div.span4").hide(1000);
															}
													});
												} 
											});
									}
							}
						}
          }			
				},
				credits: {
					enabled: false
				},
				loading: {
						hideDuration: 1000,
						showDuration: 1000
				}		
			});
			
			$.ajax({
				url: WQMS.alamat + 'grafHarini_d_smlm.php?param=' + param + '&dt=' + dt,
				success: function(data) {
					if ( WQMS.isEmptyObject( data ) == false)
					{
						//Jernihkan yang lama
						while (WQMS.chart.series.length > 0) {
							WQMS.chart.series[0].remove(true);
						}
						//istihar JSON
						var jsonObj = {
							series: []
						};

						//Buat pusingan pada setiap JSON yang dikembalikan
						$.each(data, function (i, item) {
							var key = item['name'];
							var value = item['data'];
							var showInLegend = item['showInLegend'];
							//var fillColor = item['fillColor'];
							//var lineColor = item['lineColor'];
							var zIndex = item['zIndex'];
							var beza = item['beza'];
							jsonObj.series.push({
								"name": key,
								"data": value,
								"showInLegend": showInLegend,
								//"fillColor": fillColor,
								//"lineColor": lineColor,
								"zIndex": zIndex,
								"beza": beza
							});
						});
						//Tambah sos dan kicap
						for (var i in jsonObj.series) {
							WQMS.chart.addSeries(jsonObj.series[i])
						}
						//console.log(WQMS.chart);
						$('#placeholder').show();
						WQMS.chart.redraw();
					} else {
						$('#placeholder').hide('normal');
					}
				},
				cache: false
			});

		},		
		graf_utk_manual: function( param, dt )
		{
			$('#graf_utk_manual').show('normal');	
			var options = {
				chart: {
					renderTo: 'placeholder2',
					type: 'column'
				},
				xAxis: { categories: [],
									labels: {
											rotation: -90,
											align: 'right',
											style: {
													fontSize: '13px',
													fontFamily: 'Verdana, sans-serif'
											}
									} 
								},
				title: {text: null},
				yAxis: {
					title: {text: null},
					plotLines: [{
						value: 0,
						width: 1,
						color: '#808080'
					}]
				},
				legend: {enabled: false},
				tooltip: {
					 backgroundColor: {
							linearGradient: [0, 0, 10, 40],
							stops: [
								 [0, 'rgba(255, 255, 0, .7)'],
								 [1, 'rgba(255, 255, 0, .4)']
							]
					 },
					 borderWidth: 0,
					 style: {
							color: '#000'
					 },		
					formatter: function() {
						var s = '<b>'+ this.x +'</b>';
						$.each(this.points, function(i, point) {
								s += '<br/><span style="color: ' + point.series.color + '">'+ point.series.name +'</span>: '+point.y;
						});
						return s;
					},
					shared: true			
				},
				credits: {
					enabled: false
				},
				plotOptions: {
					area: {
						marker: {
							enabled: false,
							symbol: 'circle',
							radius: 2,
							states: {
									hover: {
											enabled: true
									}
							}
						}
					}			 
				},
				series: []
			};
			
			var tinu;
			var d = dt.split("-");
			var tarikh = new Date( d[0],(d[1]-1),d[2] );
			tarikh = WQMS.blnSyamsiah[tarikh.getMonth()] + ', ' + tarikh.getFullYear();
			
			$.ajax({
				type:'GET',
				dataType:'json',
				url: WQMS.alamat + 'lokasi_sampel.php?dt=' + dt,
				success: function(data){
					if ( WQMS.isEmptyObject( data ) == false)
					{
						options.xAxis.categories = [];
						$.each(data, function(key, value) {
								options.xAxis.categories.push(value);
						});
						//console.log(options.xAxis.categories);
						
						$.ajax({
							type:'GET',
							dataType:'json',
							url: WQMS.alamat + 'graf_utk_manual.php?param=' + param + '&dt=' + dt,
							success: function(dato){
								if ( WQMS.isEmptyObject( dato ) == false)
								{
									
									//istihar JSON
									var jsonObj = {
										series: []
									};

									$.each(dato, function (i, item) {
										var key = item['name'];
										var value = item['data'];
										var enableMouseTracking = item['enableMouseTracking'];
										var showInLegend = item['showInLegend'];
										var fillColor = item['fillColor'];
										var lineColor = item['lineColor'];
										var zIndex = item['zIndex'];
										jsonObj.series.push({
											"name": key,
											"data": value,
											"enableMouseTracking": enableMouseTracking,
											"showInLegend": showInLegend,
											"fillColor": fillColor,
											"lineColor": lineColor,
											"zIndex": zIndex
										});
									});

									//options.series.push(jsonObj.series)					
									for (var i in jsonObj.series) {
										options.series.push(jsonObj.series[i])	
									}
									WQMS.carta = new Highcharts.Chart(options);
									
									//WQMS.carta.redraw();
								} 
							}
						});
						if (param == 'WQI')
							tinu = 'Bulan: <strong>' + tarikh + '</strong><br />Parameter: <strong>Indeks Kualiti Air</strong>';
						else if (param == 'BOD')
							tinu = 'Bulan: <strong>' + tarikh + '</strong><br />Parameter: <strong>Biological Oxygen Demand</strong>';
						else if (param == 'COD')
							tinu = 'Bulan: <strong>' + tarikh + '</strong><br />Parameter: <strong>Chemical Oxygen Demand</strong>';
						else if (param == 'TSS')
							tinu = 'Bulan: <strong>' + tarikh + '</strong><br />Parameter: <strong>Total Suspended Solid</strong>';
						else if (param == 'pH')
							tinu = 'Bulan: <strong>' + tarikh + '</strong><br />Parameter: <strong>pH</strong>';
						else if (param == 'NH3')
							tinu = 'Bulan: <strong>' + tarikh + '</strong><br />Parameter: <strong>NH3</strong>';
						else if (param == 'DO')
							tinu = 'Bulan: <strong>' + tarikh + '</strong><br />Parameter: <strong>Dissolved Oxygen</strong>';
						$('p.graf_utk_manual').html( tinu );
						$('#placeholder2').show();
					} else {
						$('p.graf_utk_manual').html( '<img alt="Persampelan air sungai sedang dijalankan" width="200" src="http://wqms.info/foto/manual_sampel.jpg" class="img-polaroid pull-left" style="margin-right: 10px">Bagi memastikan kualiti dan ketepatan data yang tersedia di halaman ini, sampel air sungai juga diambil dan dianalisa di makmal untuk dibanding dengan data yang diperolehi dari sensor automatik. <p class="muted">Tiada data sampel air diperolehi bagi ' + tarikh + '</p><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />');
						$('#placeholder2').hide();
					}
				}
			});
		},
		graf_ave_mth: function( moon, year )
		{
			WQMS.carta && WQMS.carta.destroy();
			WQMS.carta = null;
			var options = {
				chart: {
					renderTo: 'placeholder',
					type: 'column'
				},
				xAxis: { categories: [] },
				title: {text: null},
				yAxis: { title: { text: null } },
				legend: {enabled: false},
				tooltip: {
					 backgroundColor: {
							linearGradient: [0, 0, 10, 40],
							stops: [
								 [0, 'rgba(255, 255, 0, .7)'],
								 [1, 'rgba(255, 255, 0, .4)']
							]
					 },
					 borderWidth: 0,
					 style: {
							color: '#000'
					 },		
					formatter: function() {
						var	s = this.x +': '+this.y;
						return s;
					}		
				},
				credits: {
					enabled: false
				},
				series: []
			};

			options.xAxis.categories = [];
			$.each(WQMS.susunParam, function(key, value) {
				if (key != WQMS.susunParam.length - 1) 
					options.xAxis.categories.push(value);
			});
						
			$.ajax({
				type:'GET',
				dataType:'json',
				url: WQMS.alamat + 'laporan_bulanan.php?moon=' + moon + '&year=' + year,
				success: function(dato){
					if ( WQMS.isEmptyObject( dato ) == false)
					{
						var series = { data: [] };
						$.each(dato, function(key, value) {
							if (key == dato.length - 1) {
								$('div#purata-bulane > table > tbody > tr > td:first-child').html(value.toFixed(2) + '%');
								$('div#purata-bulane > table > tbody > tr > td:first-child').css("color", "#000");
								$('div#purata-bulane > table > tbody > tr > td:first-child').css("font-size", "32px");
								$('div#purata-bulane > table > tbody > tr > td:nth-child(2)').html( WQMS.Pengkelasan_Param( 'WQI', value ));
								$('div#purata-bulane > table > tbody > tr > td:nth-child(2)').css("color", "#000");
								$('div#purata-bulane > table > tbody > tr > td:nth-child(2)').css("font-size", "32px");
							} else {
								series.data.push(value);
							}
						});
						options.series.push(series);
						WQMS.carta = new Highcharts.Chart(options);
					}
				}
			});
		},
		jadual_lapuran_mingguan: function  ( moon, yr )
		{
			$("#purata-minggue > table.table > tbody").empty();
			$.getJSON(WQMS.alamat+'table_for_weekly_data.php', {moon: moon, yr: yr}, function(data) {
				$.each(data, function(index, lol) {
					var scan_date = $('<td></td>').html(lol.d1 + ' - ' + lol.d2);
					var pH        = $('<td></td>').html(lol.pH);
					var nh4       = $('<td></td>').html(lol.NH4);
					var tDO       = $('<td></td>').html(lol.LDO);
					var dosat     = $('<td></td>').html(lol.dosat);
					var BOD       = $('<td></td>').html(lol.sBOD);
					var COD       = $('<td></td>').html(lol.sCOD);
					var TSS       = $('<td></td>').html(lol.TSS);
					var wqi       = $('<td></td>').html(lol.wqi_week);
					var WQClass   = $('<td></td>').html(lol.fclass);
					var newTr     = $('<tr></tr>');
					newTr.append(scan_date).show();
					newTr.append(pH).show();
					newTr.append(nh4).show();
					newTr.append(tDO).show();
					newTr.append(dosat).show();
					newTr.append(BOD).show();
					newTr.append(COD).show();
					newTr.append(TSS).show();
					newTr.append(wqi).show();
					newTr.append(WQClass).show();
					$("#purata-minggue > table.table").append(newTr);

				});
				WQMS.jadual_lapuran_harian( moon, yr );
			});
		},
		jadual_lapuran_harian: function  ( moon, yr )
		{
			$("#purata-harian > table.table > tbody").empty();
			$.getJSON(WQMS.alamat+'jadual_harian.php', {moon: moon, yr: yr}, function(data) {
				$.each(data, function(index, lol) {
					var scan_date = $('<td></td>').html(lol.tarikhShj);
					var pH        = $('<td></td>').html(lol.pH);
					var nh4       = $('<td></td>').html(lol.NH4);
					var tDO       = $('<td></td>').html(lol.LDO);
					var dosat     = $('<td></td>').html(lol.dosat);
					var BOD       = $('<td></td>').html(lol.sBOD);
					var COD       = $('<td></td>').html(lol.sCOD);
					var TSS       = $('<td></td>').html(lol.TSS);
					var wqi       = $('<td></td>').html(lol.sWqi);
					var WQClass   = $('<td></td>').html(lol.kelas);
					var newTr     = $('<tr></tr>');
					newTr.append(scan_date).show();
					newTr.append(pH).show();
					newTr.append(nh4).show();
					newTr.append(tDO).show();
					newTr.append(dosat).show();
					newTr.append(BOD).show();
					newTr.append(COD).show();
					newTr.append(TSS).show();
					newTr.append(wqi).show();
					newTr.append(WQClass).show();
					$("#purata-harian > table.table").append(newTr);

				});
			});
		}	
	}
})();
/*!
* Bootstrap.js
*/
!function(e){e(function(){"use strict";e.support.transition=function(){var e=function(){var e=document.createElement("bootstrap"),t={WebkitTransition:"webkitTransitionEnd",MozTransition:"transitionend",OTransition:"oTransitionEnd otransitionend",transition:"transitionend"},n;for(n in t)if(e.style[n]!==undefined)return t[n]}();return e&&{end:e}}()})}(window.jQuery),!function(e){"use strict";var t='[data-dismiss="alert"]',n=function(n){e(n).on("click",t,this.close)};n.prototype.close=function(t){function s(){i.trigger("closed").remove()}var n=e(this),r=n.attr("data-target"),i;r||(r=n.attr("href"),r=r&&r.replace(/.*(?=#[^\s]*$)/,"")),i=e(r),t&&t.preventDefault(),i.length||(i=n.hasClass("alert")?n:n.parent()),i.trigger(t=e.Event("close"));if(t.isDefaultPrevented())return;i.removeClass("in"),e.support.transition&&i.hasClass("fade")?i.on(e.support.transition.end,s):s()},e.fn.alert=function(t){return this.each(function(){var r=e(this),i=r.data("alert");i||r.data("alert",i=new n(this)),typeof t=="string"&&i[t].call(r)})},e.fn.alert.Constructor=n,e(function(){e("body").on("click.alert.data-api",t,n.prototype.close)})}(window.jQuery),!function(e){"use strict";var t=function(t,n){this.$element=e(t),this.options=e.extend({},e.fn.button.defaults,n)};t.prototype.setState=function(e){var t="disabled",n=this.$element,r=n.data(),i=n.is("input")?"val":"html";e+="Text",r.resetText||n.data("resetText",n[i]()),n[i](r[e]||this.options[e]),setTimeout(function(){e=="loadingText"?n.addClass(t).attr(t,t):n.removeClass(t).removeAttr(t)},0)},t.prototype.toggle=function(){var e=this.$element.parent('[data-toggle="buttons-radio"]');e&&e.find(".active").removeClass("active"),this.$element.toggleClass("active")},e.fn.button=function(n){return this.each(function(){var r=e(this),i=r.data("button"),s=typeof n=="object"&&n;i||r.data("button",i=new t(this,s)),n=="toggle"?i.toggle():n&&i.setState(n)})},e.fn.button.defaults={loadingText:"loading..."},e.fn.button.Constructor=t,e(function(){e("body").on("click.button.data-api","[data-toggle^=button]",function(t){var n=e(t.target);n.hasClass("btn")||(n=n.closest(".btn")),n.button("toggle")})})}(window.jQuery),!function(e){"use strict";var t=function(t,n){this.$element=e(t),this.options=n,this.options.slide&&this.slide(this.options.slide),this.options.pause=="hover"&&this.$element.on("mouseenter",e.proxy(this.pause,this)).on("mouseleave",e.proxy(this.cycle,this))};t.prototype={cycle:function(t){return t||(this.paused=!1),this.options.interval&&!this.paused&&(this.interval=setInterval(e.proxy(this.next,this),this.options.interval)),this},to:function(t){var n=this.$element.find(".item.active"),r=n.parent().children(),i=r.index(n),s=this;if(t>r.length-1||t<0)return;return this.sliding?this.$element.one("slid",function(){s.to(t)}):i==t?this.pause().cycle():this.slide(t>i?"next":"prev",e(r[t]))},pause:function(t){return t||(this.paused=!0),this.$element.find(".next, .prev").length&&e.support.transition.end&&(this.$element.trigger(e.support.transition.end),this.cycle()),clearInterval(this.interval),this.interval=null,this},next:function(){if(this.sliding)return;return this.slide("next")},prev:function(){if(this.sliding)return;return this.slide("prev")},slide:function(t,n){var r=this.$element.find(".item.active"),i=n||r[t](),s=this.interval,o=t=="next"?"left":"right",u=t=="next"?"first":"last",a=this,f=e.Event("slide",{relatedTarget:i[0]});this.sliding=!0,s&&this.pause(),i=i.length?i:this.$element.find(".item")[u]();if(i.hasClass("active"))return;if(e.support.transition&&this.$element.hasClass("slide")){this.$element.trigger(f);if(f.isDefaultPrevented())return;i.addClass(t),i[0].offsetWidth,r.addClass(o),i.addClass(o),this.$element.one(e.support.transition.end,function(){i.removeClass([t,o].join(" ")).addClass("active"),r.removeClass(["active",o].join(" ")),a.sliding=!1,setTimeout(function(){a.$element.trigger("slid")},0)})}else{this.$element.trigger(f);if(f.isDefaultPrevented())return;r.removeClass("active"),i.addClass("active"),this.sliding=!1,this.$element.trigger("slid")}return s&&this.cycle(),this}},e.fn.carousel=function(n){return this.each(function(){var r=e(this),i=r.data("carousel"),s=e.extend({},e.fn.carousel.defaults,typeof n=="object"&&n),o=typeof n=="string"?n:s.slide;i||r.data("carousel",i=new t(this,s)),typeof n=="number"?i.to(n):o?i[o]():s.interval&&i.cycle()})},e.fn.carousel.defaults={interval:5e3,pause:"hover"},e.fn.carousel.Constructor=t,e(function(){e("body").on("click.carousel.data-api","[data-slide]",function(t){var n=e(this),r,i=e(n.attr("data-target")||(r=n.attr("href"))&&r.replace(/.*(?=#[^\s]+$)/,"")),s=!i.data("modal")&&e.extend({},i.data(),n.data());i.carousel(s),t.preventDefault()})})}(window.jQuery),!function(e){"use strict";var t=function(t,n){this.$element=e(t),this.options=e.extend({},e.fn.collapse.defaults,n),this.options.parent&&(this.$parent=e(this.options.parent)),this.options.toggle&&this.toggle()};t.prototype={constructor:t,dimension:function(){var e=this.$element.hasClass("width");return e?"width":"height"},show:function(){var t,n,r,i;if(this.transitioning)return;t=this.dimension(),n=e.camelCase(["scroll",t].join("-")),r=this.$parent&&this.$parent.find("> .accordion-group > .in");if(r&&r.length){i=r.data("collapse");if(i&&i.transitioning)return;r.collapse("hide"),i||r.data("collapse",null)}this.$element[t](0),this.transition("addClass",e.Event("show"),"shown"),e.support.transition&&this.$element[t](this.$element[0][n])},hide:function(){var t;if(this.transitioning)return;t=this.dimension(),this.reset(this.$element[t]()),this.transition("removeClass",e.Event("hide"),"hidden"),this.$element[t](0)},reset:function(e){var t=this.dimension();return this.$element.removeClass("collapse")[t](e||"auto")[0].offsetWidth,this.$element[e!==null?"addClass":"removeClass"]("collapse"),this},transition:function(t,n,r){var i=this,s=function(){n.type=="show"&&i.reset(),i.transitioning=0,i.$element.trigger(r)};this.$element.trigger(n);if(n.isDefaultPrevented())return;this.transitioning=1,this.$element[t]("in"),e.support.transition&&this.$element.hasClass("collapse")?this.$element.one(e.support.transition.end,s):s()},toggle:function(){this[this.$element.hasClass("in")?"hide":"show"]()}},e.fn.collapse=function(n){return this.each(function(){var r=e(this),i=r.data("collapse"),s=typeof n=="object"&&n;i||r.data("collapse",i=new t(this,s)),typeof n=="string"&&i[n]()})},e.fn.collapse.defaults={toggle:!0},e.fn.collapse.Constructor=t,e(function(){e("body").on("click.collapse.data-api","[data-toggle=collapse]",function(t){var n=e(this),r,i=n.attr("data-target")||t.preventDefault()||(r=n.attr("href"))&&r.replace(/.*(?=#[^\s]+$)/,""),s=e(i).data("collapse")?"toggle":n.data();n[e(i).hasClass("in")?"addClass":"removeClass"]("collapsed"),e(i).collapse(s)})})}(window.jQuery),!function(e){"use strict";function r(){i(e(t)).removeClass("open")}function i(t){var n=t.attr("data-target"),r;return n||(n=t.attr("href"),n=n&&n.replace(/.*(?=#[^\s]*$)/,"")),r=e(n),r.length||(r=t.parent()),r}var t="[data-toggle=dropdown]",n=function(t){var n=e(t).on("click.dropdown.data-api",this.toggle);e("html").on("click.dropdown.data-api",function(){n.parent().removeClass("open")})};n.prototype={constructor:n,toggle:function(t){var n=e(this),s,o;if(n.is(".disabled, :disabled"))return;return s=i(n),o=s.hasClass("open"),r(),o||(s.toggleClass("open"),n.focus()),!1},keydown:function(t){var n,r,s,o,u,a;if(!/(38|40|27)/.test(t.keyCode))return;n=e(this),t.preventDefault(),t.stopPropagation();if(n.is(".disabled, :disabled"))return;o=i(n),u=o.hasClass("open");if(!u||u&&t.keyCode==27)return n.click();r=e("[role=menu] li:not(.divider) a",o);if(!r.length)return;a=r.index(r.filter(":focus")),t.keyCode==38&&a>0&&a--,t.keyCode==40&&a<r.length-1&&a++,~a||(a=0),r.eq(a).focus()}},e.fn.dropdown=function(t){return this.each(function(){var r=e(this),i=r.data("dropdown");i||r.data("dropdown",i=new n(this)),typeof t=="string"&&i[t].call(r)})},e.fn.dropdown.Constructor=n,e(function(){e("html").on("click.dropdown.data-api touchstart.dropdown.data-api",r),e("body").on("click.dropdown touchstart.dropdown.data-api",".dropdown",function(e){e.stopPropagation()}).on("click.dropdown.data-api touchstart.dropdown.data-api",t,n.prototype.toggle).on("keydown.dropdown.data-api touchstart.dropdown.data-api",t+", [role=menu]",n.prototype.keydown)})}(window.jQuery),!function(e){"use strict";var t=function(t,n){this.options=n,this.$element=e(t).delegate('[data-dismiss="modal"]',"click.dismiss.modal",e.proxy(this.hide,this)),this.options.remote&&this.$element.find(".modal-body").load(this.options.remote)};t.prototype={constructor:t,toggle:function(){return this[this.isShown?"hide":"show"]()},show:function(){var t=this,n=e.Event("show");this.$element.trigger(n);if(this.isShown||n.isDefaultPrevented())return;e("body").addClass("modal-open"),this.isShown=!0,this.escape(),this.backdrop(function(){var n=e.support.transition&&t.$element.hasClass("fade");t.$element.parent().length||t.$element.appendTo(document.body),t.$element.show(),n&&t.$element[0].offsetWidth,t.$element.addClass("in").attr("aria-hidden",!1).focus(),t.enforceFocus(),n?t.$element.one(e.support.transition.end,function(){t.$element.trigger("shown")}):t.$element.trigger("shown")})},hide:function(t){t&&t.preventDefault();var n=this;t=e.Event("hide"),this.$element.trigger(t);if(!this.isShown||t.isDefaultPrevented())return;this.isShown=!1,e("body").removeClass("modal-open"),this.escape(),e(document).off("focusin.modal"),this.$element.removeClass("in").attr("aria-hidden",!0),e.support.transition&&this.$element.hasClass("fade")?this.hideWithTransition():this.hideModal()},enforceFocus:function(){var t=this;e(document).on("focusin.modal",function(e){t.$element[0]!==e.target&&!t.$element.has(e.target).length&&t.$element.focus()})},escape:function(){var e=this;this.isShown&&this.options.keyboard?this.$element.on("keyup.dismiss.modal",function(t){t.which==27&&e.hide()}):this.isShown||this.$element.off("keyup.dismiss.modal")},hideWithTransition:function(){var t=this,n=setTimeout(function(){t.$element.off(e.support.transition.end),t.hideModal()},500);this.$element.one(e.support.transition.end,function(){clearTimeout(n),t.hideModal()})},hideModal:function(e){this.$element.hide().trigger("hidden"),this.backdrop()},removeBackdrop:function(){this.$backdrop.remove(),this.$backdrop=null},backdrop:function(t){var n=this,r=this.$element.hasClass("fade")?"fade":"";if(this.isShown&&this.options.backdrop){var i=e.support.transition&&r;this.$backdrop=e('<div class="modal-backdrop '+r+'" />').appendTo(document.body),this.options.backdrop!="static"&&this.$backdrop.click(e.proxy(this.hide,this)),i&&this.$backdrop[0].offsetWidth,this.$backdrop.addClass("in"),i?this.$backdrop.one(e.support.transition.end,t):t()}else!this.isShown&&this.$backdrop?(this.$backdrop.removeClass("in"),e.support.transition&&this.$element.hasClass("fade")?this.$backdrop.one(e.support.transition.end,e.proxy(this.removeBackdrop,this)):this.removeBackdrop()):t&&t()}},e.fn.modal=function(n){return this.each(function(){var r=e(this),i=r.data("modal"),s=e.extend({},e.fn.modal.defaults,r.data(),typeof n=="object"&&n);i||r.data("modal",i=new t(this,s)),typeof n=="string"?i[n]():s.show&&i.show()})},e.fn.modal.defaults={backdrop:!0,keyboard:!0,show:!0},e.fn.modal.Constructor=t,e(function(){e("body").on("click.modal.data-api",'[data-toggle="modal"]',function(t){var n=e(this),r=n.attr("href"),i=e(n.attr("data-target")||r&&r.replace(/.*(?=#[^\s]+$)/,"")),s=i.data("modal")?"toggle":e.extend({remote:!/#/.test(r)&&r},i.data(),n.data());t.preventDefault(),i.modal(s).one("hide",function(){n.focus()})})})}(window.jQuery),!function(e){"use strict";var t=function(e,t){this.init("tooltip",e,t)};t.prototype={constructor:t,init:function(t,n,r){var i,s;this.type=t,this.$element=e(n),this.options=this.getOptions(r),this.enabled=!0,this.options.trigger=="click"?this.$element.on("click."+this.type,this.options.selector,e.proxy(this.toggle,this)):this.options.trigger!="manual"&&(i=this.options.trigger=="hover"?"mouseenter":"focus",s=this.options.trigger=="hover"?"mouseleave":"blur",this.$element.on(i+"."+this.type,this.options.selector,e.proxy(this.enter,this)),this.$element.on(s+"."+this.type,this.options.selector,e.proxy(this.leave,this))),this.options.selector?this._options=e.extend({},this.options,{trigger:"manual",selector:""}):this.fixTitle()},getOptions:function(t){return t=e.extend({},e.fn[this.type].defaults,t,this.$element.data()),t.delay&&typeof t.delay=="number"&&(t.delay={show:t.delay,hide:t.delay}),t},enter:function(t){var n=e(t.currentTarget)[this.type](this._options).data(this.type);if(!n.options.delay||!n.options.delay.show)return n.show();clearTimeout(this.timeout),n.hoverState="in",this.timeout=setTimeout(function(){n.hoverState=="in"&&n.show()},n.options.delay.show)},leave:function(t){var n=e(t.currentTarget)[this.type](this._options).data(this.type);this.timeout&&clearTimeout(this.timeout);if(!n.options.delay||!n.options.delay.hide)return n.hide();n.hoverState="out",this.timeout=setTimeout(function(){n.hoverState=="out"&&n.hide()},n.options.delay.hide)},show:function(){var e,t,n,r,i,s,o;if(this.hasContent()&&this.enabled){e=this.tip(),this.setContent(),this.options.animation&&e.addClass("fade"),s=typeof this.options.placement=="function"?this.options.placement.call(this,e[0],this.$element[0]):this.options.placement,t=/in/.test(s),e.remove().css({top:0,left:0,display:"block"}).appendTo(t?this.$element:document.body),n=this.getPosition(t),r=e[0].offsetWidth,i=e[0].offsetHeight;switch(t?s.split(" ")[1]:s){case"bottom":o={top:n.top+n.height,left:n.left+n.width/2-r/2};break;case"top":o={top:n.top-i,left:n.left+n.width/2-r/2};break;case"left":o={top:n.top+n.height/2-i/2,left:n.left-r};break;case"right":o={top:n.top+n.height/2-i/2,left:n.left+n.width}}e.css(o).addClass(s).addClass("in")}},setContent:function(){var e=this.tip(),t=this.getTitle();e.find(".tooltip-inner")[this.options.html?"html":"text"](t),e.removeClass("fade in top bottom left right")},hide:function(){function r(){var t=setTimeout(function(){n.off(e.support.transition.end).remove()},500);n.one(e.support.transition.end,function(){clearTimeout(t),n.remove()})}var t=this,n=this.tip();return n.removeClass("in"),e.support.transition&&this.$tip.hasClass("fade")?r():n.remove(),this},fixTitle:function(){var e=this.$element;(e.attr("title")||typeof e.attr("data-original-title")!="string")&&e.attr("data-original-title",e.attr("title")||"").removeAttr("title")},hasContent:function(){return this.getTitle()},getPosition:function(t){return e.extend({},t?{top:0,left:0}:this.$element.offset(),{width:this.$element[0].offsetWidth,height:this.$element[0].offsetHeight})},getTitle:function(){var e,t=this.$element,n=this.options;return e=t.attr("data-original-title")||(typeof n.title=="function"?n.title.call(t[0]):n.title),e},tip:function(){return this.$tip=this.$tip||e(this.options.template)},validate:function(){this.$element[0].parentNode||(this.hide(),this.$element=null,this.options=null)},enable:function(){this.enabled=!0},disable:function(){this.enabled=!1},toggleEnabled:function(){this.enabled=!this.enabled},toggle:function(){this[this.tip().hasClass("in")?"hide":"show"]()},destroy:function(){this.hide().$element.off("."+this.type).removeData(this.type)}},e.fn.tooltip=function(n){return this.each(function(){var r=e(this),i=r.data("tooltip"),s=typeof n=="object"&&n;i||r.data("tooltip",i=new t(this,s)),typeof n=="string"&&i[n]()})},e.fn.tooltip.Constructor=t,e.fn.tooltip.defaults={animation:!0,placement:"top",selector:!1,template:'<div class="tooltip"><div class="tooltip-arrow"></div><div class="tooltip-inner"></div></div>',trigger:"hover",title:"",delay:0,html:!0}}(window.jQuery),!function(e){"use strict";var t=function(e,t){this.init("popover",e,t)};t.prototype=e.extend({},e.fn.tooltip.Constructor.prototype,{constructor:t,setContent:function(){var e=this.tip(),t=this.getTitle(),n=this.getContent();e.find(".popover-title")[this.options.html?"html":"text"](t),e.find(".popover-content > *")[this.options.html?"html":"text"](n),e.removeClass("fade top bottom left right in")},hasContent:function(){return this.getTitle()||this.getContent()},getContent:function(){var e,t=this.$element,n=this.options;return e=t.attr("data-content")||(typeof n.content=="function"?n.content.call(t[0]):n.content),e},tip:function(){return this.$tip||(this.$tip=e(this.options.template)),this.$tip},destroy:function(){this.hide().$element.off("."+this.type).removeData(this.type)}}),e.fn.popover=function(n){return this.each(function(){var r=e(this),i=r.data("popover"),s=typeof n=="object"&&n;i||r.data("popover",i=new t(this,s)),typeof n=="string"&&i[n]()})},e.fn.popover.Constructor=t,e.fn.popover.defaults=e.extend({},e.fn.tooltip.defaults,{placement:"right",trigger:"click",content:"",template:'<div class="popover"><div class="arrow"></div><div class="popover-inner"><h3 class="popover-title"></h3><div class="popover-content"><p></p></div></div></div>'})}(window.jQuery),!function(e){"use strict";function t(t,n){var r=e.proxy(this.process,this),i=e(t).is("body")?e(window):e(t),s;this.options=e.extend({},e.fn.scrollspy.defaults,n),this.$scrollElement=i.on("scroll.scroll-spy.data-api",r),this.selector=(this.options.target||(s=e(t).attr("href"))&&s.replace(/.*(?=#[^\s]+$)/,"")||"")+" .nav li > a",this.$body=e("body"),this.refresh(),this.process()}t.prototype={constructor:t,refresh:function(){var t=this,n;this.offsets=e([]),this.targets=e([]),n=this.$body.find(this.selector).map(function(){var t=e(this),n=t.data("target")||t.attr("href"),r=/^#\w/.test(n)&&e(n);return r&&r.length&&[[r.position().top,n]]||null}).sort(function(e,t){return e[0]-t[0]}).each(function(){t.offsets.push(this[0]),t.targets.push(this[1])})},process:function(){var e=this.$scrollElement.scrollTop()+this.options.offset,t=this.$scrollElement[0].scrollHeight||this.$body[0].scrollHeight,n=t-this.$scrollElement.height(),r=this.offsets,i=this.targets,s=this.activeTarget,o;if(e>=n)return s!=(o=i.last()[0])&&this.activate(o);for(o=r.length;o--;)s!=i[o]&&e>=r[o]&&(!r[o+1]||e<=r[o+1])&&this.activate(i[o])},activate:function(t){var n,r;this.activeTarget=t,e(this.selector).parent(".active").removeClass("active"),r=this.selector+'[data-target="'+t+'"],'+this.selector+'[href="'+t+'"]',n=e(r).parent("li").addClass("active"),n.parent(".dropdown-menu").length&&(n=n.closest("li.dropdown").addClass("active")),n.trigger("activate")}},e.fn.scrollspy=function(n){return this.each(function(){var r=e(this),i=r.data("scrollspy"),s=typeof n=="object"&&n;i||r.data("scrollspy",i=new t(this,s)),typeof n=="string"&&i[n]()})},e.fn.scrollspy.Constructor=t,e.fn.scrollspy.defaults={offset:10},e(window).on("load",function(){e('[data-spy="scroll"]').each(function(){var t=e(this);t.scrollspy(t.data())})})}(window.jQuery),!function(e){"use strict";var t=function(t){this.element=e(t)};t.prototype={constructor:t,show:function(){var t=this.element,n=t.closest("ul:not(.dropdown-menu)"),r=t.attr("data-target"),i,s,o;r||(r=t.attr("href"),r=r&&r.replace(/.*(?=#[^\s]*$)/,""));if(t.parent("li").hasClass("active"))return;i=n.find(".active a").last()[0],o=e.Event("show",{relatedTarget:i}),t.trigger(o);if(o.isDefaultPrevented())return;s=e(r),this.activate(t.parent("li"),n),this.activate(s,s.parent(),function(){t.trigger({type:"shown",relatedTarget:i})})},activate:function(t,n,r){function o(){i.removeClass("active").find("> .dropdown-menu > .active").removeClass("active"),t.addClass("active"),s?(t[0].offsetWidth,t.addClass("in")):t.removeClass("fade"),t.parent(".dropdown-menu")&&t.closest("li.dropdown").addClass("active"),r&&r()}var i=n.find("> .active"),s=r&&e.support.transition&&i.hasClass("fade");s?i.one(e.support.transition.end,o):o(),i.removeClass("in")}},e.fn.tab=function(n){return this.each(function(){var r=e(this),i=r.data("tab");i||r.data("tab",i=new t(this)),typeof n=="string"&&i[n]()})},e.fn.tab.Constructor=t,e(function(){e("body").on("click.tab.data-api",'[data-toggle="tab"], [data-toggle="pill"]',function(t){t.preventDefault(),e(this).tab("show")})})}(window.jQuery),!function(e){"use strict";var t=function(t,n){this.$element=e(t),this.options=e.extend({},e.fn.typeahead.defaults,n),this.matcher=this.options.matcher||this.matcher,this.sorter=this.options.sorter||this.sorter,this.highlighter=this.options.highlighter||this.highlighter,this.updater=this.options.updater||this.updater,this.$menu=e(this.options.menu).appendTo("body"),this.source=this.options.source,this.shown=!1,this.listen()};t.prototype={constructor:t,select:function(){var e=this.$menu.find(".active").attr("data-value");return this.$element.val(this.updater(e)).change(),this.hide()},updater:function(e){return e},show:function(){var t=e.extend({},this.$element.offset(),{height:this.$element[0].offsetHeight});return this.$menu.css({top:t.top+t.height,left:t.left}),this.$menu.show(),this.shown=!0,this},hide:function(){return this.$menu.hide(),this.shown=!1,this},lookup:function(t){var n;return this.query=this.$element.val(),!this.query||this.query.length<this.options.minLength?this.shown?this.hide():this:(n=e.isFunction(this.source)?this.source(this.query,e.proxy(this.process,this)):this.source,n?this.process(n):this)},process:function(t){var n=this;return t=e.grep(t,function(e){return n.matcher(e)}),t=this.sorter(t),t.length?this.render(t.slice(0,this.options.items)).show():this.shown?this.hide():this},matcher:function(e){return~e.toLowerCase().indexOf(this.query.toLowerCase())},sorter:function(e){var t=[],n=[],r=[],i;while(i=e.shift())i.toLowerCase().indexOf(this.query.toLowerCase())?~i.indexOf(this.query)?n.push(i):r.push(i):t.push(i);return t.concat(n,r)},highlighter:function(e){var t=this.query.replace(/[\-\[\]{}()*+?.,\\\^$|#\s]/g,"\\$&");return e.replace(new RegExp("("+t+")","ig"),function(e,t){return"<strong>"+t+"</strong>"})},render:function(t){var n=this;return t=e(t).map(function(t,r){return t=e(n.options.item).attr("data-value",r),t.find("a").html(n.highlighter(r)),t[0]}),t.first().addClass("active"),this.$menu.html(t),this},next:function(t){var n=this.$menu.find(".active").removeClass("active"),r=n.next();r.length||(r=e(this.$menu.find("li")[0])),r.addClass("active")},prev:function(e){var t=this.$menu.find(".active").removeClass("active"),n=t.prev();n.length||(n=this.$menu.find("li").last()),n.addClass("active")},listen:function(){this.$element.on("blur",e.proxy(this.blur,this)).on("keypress",e.proxy(this.keypress,this)).on("keyup",e.proxy(this.keyup,this)),(e.browser.webkit||e.browser.msie)&&this.$element.on("keydown",e.proxy(this.keydown,this)),this.$menu.on("click",e.proxy(this.click,this)).on("mouseenter","li",e.proxy(this.mouseenter,this))},move:function(e){if(!this.shown)return;switch(e.keyCode){case 9:case 13:case 27:e.preventDefault();break;case 38:e.preventDefault(),this.prev();break;case 40:e.preventDefault(),this.next()}e.stopPropagation()},keydown:function(t){this.suppressKeyPressRepeat=!~e.inArray(t.keyCode,[40,38,9,13,27]),this.move(t)},keypress:function(e){if(this.suppressKeyPressRepeat)return;this.move(e)},keyup:function(e){switch(e.keyCode){case 40:case 38:break;case 9:case 13:if(!this.shown)return;this.select();break;case 27:if(!this.shown)return;this.hide();break;default:this.lookup()}e.stopPropagation(),e.preventDefault()},blur:function(e){var t=this;setTimeout(function(){t.hide()},150)},click:function(e){e.stopPropagation(),e.preventDefault(),this.select()},mouseenter:function(t){this.$menu.find(".active").removeClass("active"),e(t.currentTarget).addClass("active")}},e.fn.typeahead=function(n){return this.each(function(){var r=e(this),i=r.data("typeahead"),s=typeof n=="object"&&n;i||r.data("typeahead",i=new t(this,s)),typeof n=="string"&&i[n]()})},e.fn.typeahead.defaults={source:[],items:8,menu:'<ul class="typeahead dropdown-menu"></ul>',item:'<li><a href="#"></a></li>',minLength:1},e.fn.typeahead.Constructor=t,e(function(){e("body").on("focus.typeahead.data-api",'[data-provide="typeahead"]',function(t){var n=e(this);if(n.data("typeahead"))return;t.preventDefault(),n.typeahead(n.data())})})}(window.jQuery),!function(e){"use strict";var t=function(t,n){this.options=e.extend({},e.fn.affix.defaults,n),this.$window=e(window).on("scroll.affix.data-api",e.proxy(this.checkPosition,this)),this.$element=e(t),this.checkPosition()};t.prototype.checkPosition=function(){if(!this.$element.is(":visible"))return;var t=e(document).height(),n=this.$window.scrollTop(),r=this.$element.offset(),i=this.options.offset,s=i.bottom,o=i.top,u="affix affix-top affix-bottom",a;typeof i!="object"&&(s=o=i),typeof o=="function"&&(o=i.top()),typeof s=="function"&&(s=i.bottom()),a=this.unpin!=null&&n+this.unpin<=r.top?!1:s!=null&&r.top+this.$element.height()>=t-s?"bottom":o!=null&&n<=o?"top":!1;if(this.affixed===a)return;this.affixed=a,this.unpin=a=="bottom"?r.top-n:null,this.$element.removeClass(u).addClass("affix"+(a?"-"+a:""))},e.fn.affix=function(n){return this.each(function(){var r=e(this),i=r.data("affix"),s=typeof n=="object"&&n;i||r.data("affix",i=new t(this,s)),typeof n=="string"&&i[n]()})},e.fn.affix.Constructor=t,e.fn.affix.defaults={offset:0},e(window).on("load",function(){e('[data-spy="affix"]').each(function(){var t=e(this),n=t.data();n.offset=n.offset||{},n.offsetBottom&&(n.offset.bottom=n.offsetBottom),n.offsetTop&&(n.offset.top=n.offsetTop),t.affix(n)})})}(window.jQuery);
/*! =========================================================
 * bootstrap-datepicker.js 
 * http://www.eyecon.ro/bootstrap-datepicker
*/
 
!function( $ ) {
	
	// Picker object
	
	var Datepicker = function(element, options){
		this.element = $(element);
		this.format = DPGlobal.parseFormat(options.format||this.element.data('date-format')||'mm/dd/yyyy');
		this.picker = $(DPGlobal.template)
							.appendTo('body')
							.on({
								click: $.proxy(this.click, this),
								mousedown: $.proxy(this.mousedown, this)
							});
		this.isInput = this.element.is('input');
		this.component = this.element.is('.date') ? this.element.find('.add-on') : false;
		
		if (this.isInput) {
			this.element.on({
				focus: $.proxy(this.show, this),
				blur: $.proxy(this.hide, this),
				keyup: $.proxy(this.update, this)
			});
		} else {
			if (this.component){
				this.component.on('click', $.proxy(this.show, this));
			} else {
				this.element.on('click', $.proxy(this.show, this));
			}
		}
		
		this.viewMode = 0;
		this.weekStart = options.weekStart||this.element.data('date-weekstart')||0;
		this.weekEnd = this.weekStart == 0 ? 6 : this.weekStart - 1;
		this.fillDow();
		this.fillMonths();
		this.update();
		this.showMode();
	};
	
	Datepicker.prototype = {
		constructor: Datepicker,
		
		show: function(e) {
			this.picker.show();
			this.height = this.component ? this.component.outerHeight() : this.element.outerHeight();
			this.place();
			$(window).on('resize', $.proxy(this.place, this));
			if (e ) {
				e.stopPropagation();
				e.preventDefault();
			}
			if (!this.isInput) {
				$(document).on('mousedown', $.proxy(this.hide, this));
			}
			this.element.trigger({
				type: 'show',
				date: this.date
			});
		},
		
		hide: function(){
			this.picker.hide();
			$(window).off('resize', this.place);
			this.viewMode = 0;
			this.showMode();
			if (!this.isInput) {
				$(document).off('mousedown', this.hide);
			}
			this.setValue();
			this.element.trigger({
				type: 'hide',
				date: this.date
			});
		},
		
		setValue: function() {
			var formated = DPGlobal.formatDate(this.date, this.format);
			if (!this.isInput) {
				if (this.component){
					this.element.find('input').prop('value', formated);
				}
				this.element.data('date', formated);
			} else {
				this.element.prop('value', formated);
			}
		},
		
		place: function(){
			var offset = this.component ? this.component.offset() : this.element.offset();
			this.picker.css({
				top: offset.top + this.height,
				left: offset.left
			});
		},
		
		update: function(){
			this.date = DPGlobal.parseDate(
				this.isInput ? this.element.prop('value') : this.element.data('date'),
				this.format
			);
			this.viewDate = new Date(this.date);
			this.fill();
		},
		
		fillDow: function(){
			var dowCnt = this.weekStart;
			var html = '<tr>';
			while (dowCnt < this.weekStart + 7) {
				html += '<th class="dow">'+DPGlobal.dates.daysMin[(dowCnt++)%7]+'</th>';
			}
			html += '</tr>';
			this.picker.find('.datepicker-days thead').append(html);
		},
		
		fillMonths: function(){
			var html = '';
			var i = 0
			while (i < 12) {
				html += '<span class="month">'+DPGlobal.dates.monthsShort[i++]+'</span>';
			}
			this.picker.find('.datepicker-months td').append(html);
		},
		
		fill: function() {
			var d = new Date(this.viewDate),
				year = d.getFullYear(),
				month = d.getMonth(),
				currentDate = this.date.valueOf();
			this.picker.find('.datepicker-days th:eq(1)')
						.text(DPGlobal.dates.months[month]+' '+year);
			var prevMonth = new Date(year, month-1, 28,0,0,0,0),
				day = DPGlobal.getDaysInMonth(prevMonth.getFullYear(), prevMonth.getMonth());
			prevMonth.setDate(day);
			prevMonth.setDate(day - (prevMonth.getDay() - this.weekStart + 7)%7);
			var nextMonth = new Date(prevMonth);
			nextMonth.setDate(nextMonth.getDate() + 42);
			nextMonth = nextMonth.valueOf();
			html = [];
			var clsName;
			while(prevMonth.valueOf() < nextMonth) {
				if (prevMonth.getDay() == this.weekStart) {
					html.push('<tr>');
				}
				clsName = '';
				if (prevMonth.getMonth() < month) {
					clsName += ' old';
				} else if (prevMonth.getMonth() > month) {
					clsName += ' new';
				}
				if (prevMonth.valueOf() == currentDate) {
					clsName += ' active';
				}
				html.push('<td class="day'+clsName+'">'+prevMonth.getDate() + '</td>');
				if (prevMonth.getDay() == this.weekEnd) {
					html.push('</tr>');
				}
				prevMonth.setDate(prevMonth.getDate()+1);
			}
			this.picker.find('.datepicker-days tbody').empty().append(html.join(''));
			var currentYear = this.date.getFullYear();
			
			var months = this.picker.find('.datepicker-months')
						.find('th:eq(1)')
							.text(year)
							.end()
						.find('span').removeClass('active');
			if (currentYear == year) {
				months.eq(this.date.getMonth()).addClass('active');
			}
			
			html = '';
			year = parseInt(year/10, 10) * 10;
			var yearCont = this.picker.find('.datepicker-years')
								.find('th:eq(1)')
									.text(year + '-' + (year + 9))
									.end()
								.find('td');
			year -= 1;
			for (var i = -1; i < 11; i++) {
				html += '<span class="year'+(i == -1 || i == 10 ? ' old' : '')+(currentYear == year ? ' active' : '')+'">'+year+'</span>';
				year += 1;
			}
			yearCont.html(html);
		},
		
		click: function(e) {
			e.stopPropagation();
			e.preventDefault();
			var target = $(e.target).closest('span, td, th');
			if (target.length == 1) {
				switch(target[0].nodeName.toLowerCase()) {
					case 'th':
						switch(target[0].className) {
							case 'switch':
								this.showMode(1);
								break;
							case 'prev':
							case 'next':
								this.viewDate['set'+DPGlobal.modes[this.viewMode].navFnc].call(
									this.viewDate,
									this.viewDate['get'+DPGlobal.modes[this.viewMode].navFnc].call(this.viewDate) + 
									DPGlobal.modes[this.viewMode].navStep * (target[0].className == 'prev' ? -1 : 1)
								);
								this.fill();
								break;
						}
						break;
					case 'span':
						if (target.is('.month')) {
							var month = target.parent().find('span').index(target);
							this.viewDate.setMonth(month);
						} else {
							var year = parseInt(target.text(), 10)||0;
							this.viewDate.setFullYear(year);
						}
						this.showMode(-1);
						this.fill();
						break;
					case 'td':
						if (target.is('.day')){
							var day = parseInt(target.text(), 10)||1;
							var month = this.viewDate.getMonth();
							if (target.is('.old')) {
								month -= 1;
							} else if (target.is('.new')) {
								month += 1;
							}
							var year = this.viewDate.getFullYear();
							this.date = new Date(year, month, day,0,0,0,0);
							this.viewDate = new Date(year, month, day,0,0,0,0);
							this.fill();
							this.setValue();
							this.element.trigger({
								type: 'changeDate',
								date: this.date
							});
						}
						break;
				}
			}
		},
		
		mousedown: function(e){
			e.stopPropagation();
			e.preventDefault();
		},
		
		showMode: function(dir) {
			if (dir) {
				this.viewMode = Math.max(0, Math.min(2, this.viewMode + dir));
			}
			this.picker.find('>div').hide().filter('.datepicker-'+DPGlobal.modes[this.viewMode].clsName).show();
		}
	};
	
	$.fn.datepicker = function ( option ) {
		return this.each(function () {
			var $this = $(this),
				data = $this.data('datepicker'),
				options = typeof option == 'object' && option;
			if (!data) {
				$this.data('datepicker', (data = new Datepicker(this, $.extend({}, $.fn.datepicker.defaults,options))));
			}
			if (typeof option == 'string') data[option]();
		});
	};

	$.fn.datepicker.defaults = {
	};
	$.fn.datepicker.Constructor = Datepicker;
	
	var DPGlobal = {
		modes: [
			{
				clsName: 'days',
				navFnc: 'Month',
				navStep: 1
			},
			{
				clsName: 'months',
				navFnc: 'FullYear',
				navStep: 1
			},
			{
				clsName: 'years',
				navFnc: 'FullYear',
				navStep: 10
		}],
		dates:{
			days: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday", "Sunday"],
			daysShort: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat", "Sun"],
			daysMin: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa", "Su"],
			months: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
			monthsShort: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"]
		},
		isLeapYear: function (year) {
			return (((year % 4 === 0) && (year % 100 !== 0)) || (year % 400 === 0))
		},
		getDaysInMonth: function (year, month) {
			return [31, (DPGlobal.isLeapYear(year) ? 29 : 28), 31, 30, 31, 30, 31, 31, 30, 31, 30, 31][month]
		},
		parseFormat: function(format){
			var separator = format.match(/[.\/-].*?/),
				parts = format.split(/\W+/);
			if (!separator || !parts || parts.length == 0){
				throw new Error("Invalid date format.");
			}
			return {separator: separator, parts: parts};
		},
		parseDate: function(date, format) {
			var parts = date.split(format.separator),
				date = new Date(1970, 1, 1, 0, 0, 0),
				val;
			if (parts.length == format.parts.length) {
				for (var i=0, cnt = format.parts.length; i < cnt; i++) {
					val = parseInt(parts[i], 10)||1;
					switch(format.parts[i]) {
						case 'dd':
						case 'd':
							date.setDate(val);
							break;
						case 'mm':
						case 'm':
							date.setMonth(val - 1);
							break;
						case 'yy':
							date.setFullYear(2000 + val);
							break;
						case 'yyyy':
							date.setFullYear(val);
							break;
					}
				}
			}
			return date;
		},
		formatDate: function(date, format){
			var val = {
				d: date.getDate(),
				m: date.getMonth() + 1,
				yy: date.getFullYear().toString().substring(2),
				yyyy: date.getFullYear()
			};
			val.dd = (val.d < 10 ? '0' : '') + val.d;
			val.mm = (val.m < 10 ? '0' : '') + val.m;
			var date = [];
			for (var i=0, cnt = format.parts.length; i < cnt; i++) {
				date.push(val[format.parts[i]]);
			}
			return date.join(format.separator);
		},
		headTemplate: '<thead>'+
							'<tr>'+
								'<th class="prev"><i class="icon-arrow-left"/></th>'+
								'<th colspan="5" class="switch"></th>'+
								'<th class="next"><i class="icon-arrow-right"/></th>'+
							'</tr>'+
						'</thead>',
		contTemplate: '<tbody><tr><td colspan="7"></td></tr></tbody>'
	};
	DPGlobal.template = '<div class="datepicker dropdown-menu">'+
							'<div class="datepicker-days">'+
								'<table class=" table-condensed">'+
									DPGlobal.headTemplate+
									'<tbody></tbody>'+
								'</table>'+
							'</div>'+
							'<div class="datepicker-months">'+
								'<table class="table-condensed">'+
									DPGlobal.headTemplate+
									DPGlobal.contTemplate+
								'</table>'+
							'</div>'+
							'<div class="datepicker-years">'+
								'<table class="table-condensed">'+
									DPGlobal.headTemplate+
									DPGlobal.contTemplate+
								'</table>'+
							'</div>'+
						'</div>';

}( window.jQuery )